global modelnumber

var 
a_be            % Shock (positive) wealth redistribution to entrepreneurs - negative shock to banks
a_bh            % Shock (positive) wealth redistribution to impatient household - negative shock to banks
a_j             % Shock housing preference
a_k             % Shock capital
a_me            % Shock to entrepreneur's capital constraint
a_mh            % Shock to bank's capital adequacy constraint
a_p             % Shock to consumption preference
a_zc            % Shock to TFP consumption sector
a_zh            % Shock to TFP housing sector
a_s             % Persistent shock to taylor rule AR(1)
acdb            % adjustment costs deposits banks 
acdh            % adjustment costs deposits patient households
ackh_c          % adjustment costs consumption capital patient households
ackh_h          % adjustment costs housing capital patient households
acke            % adjustment costs capital entrpeneurs
acloeb          % adjustment costs loans to entrepreneurs bank
acloee          % adjustment costs loans entrepreneurs
aclosb          % adjustment costs loans impatient household bank
acloss          % adjustment costs loans impatient household
cb              % consumption bank
ce              % consumption entrepreneur 
ch              % consumption patient household
cs              % consumption impatient household
ctot            % total consumption 
d               % deposits 
data_CC         % percentage change -> total optimal consumption divided by total steady state consumption 
data_CH
data_CS
data_II         % percentage change -> total optimal investment divided by total steady state investment 
data_LLE        % = a_be 
data_LLH        % = a_bh (redistribution shock)
data_LO         % change -> total loan supply divided by total steady state loan supply
data_LOE        % change-> total loan supply entrepreneurs divided by total steady state loan supply entrepreneurs  
data_LOH        % change -> total loan supply impatient household divided by total steady state loan supply impatient household
data_NN_C       % change -> total labour supply divided by total steady state labour supply 
data_NN_H
data_QQ         % change -> house prices divided by the steady state house price
data_TFP        % technology shock
data_YY         % percentage change
data_HH
data_HS
data_HR
data_HR_stock
data_QR
data_HMORT      % mortgaged housing stock without rented properties 
data_HHO        % owned housing stock without rented properties   
data_QQ_QR 
data_HOWNER
data_IH
data_infl
data_RH
dke             % depreciation rate capital entrepreneur
dkh_c           % depreciation rate capital patient households - consumption sector
dkh_h           % depreciation rate capital patient households - housing sector
e_a_be          % a_be(+1)next period's redistribution shock entrepreneur/banks 
e_a_bh          % a_bh(+1)next period's redistribution shock impatient household/banks 
hh              % housing patient household              
hs              % housing impatient household 
hstilda         % housing impatient household (auxilary variable)
hr              % rental housing
hr_ratio
IH              % output housing 
itot            % total investment 
ke              % capital entrepreneur 
kh_c            % capital patient household - consumption sector
kh_h            % capital patient household - housing sector
kb              % intermediate input
ktot            % total capital 
lambdab         % lagrangian multiplier on bank's capital adequacy constraint 
lambdae         % lagrangian multiplier on entrepreneur's collateral constraint 
lambdas         % lagrangian multiplier on impatient household's collateral constraint
loe             % loans issued to entrepreneurs
los             % loans issued to impatient households
nh_c            % labour supply patient households - consumption sector
nh_h            % labour supply patient households - housing sector 
ns_c            % labour supply impatient households - consumption sector
ns_h            % labour supply impatient households - housing sector
ntot_c          % total labour supply - consumption sector
ntot_h          % total labour supply - housing sector
pl              % land price
price_rent_ratio
q               % price real estate
qr              % rent paid by impatient households
re              % interst on loans paid by entrepreneurs 
rh              % interst on deposits received by patient households
rk              % interst on capital entrepreneurs (comes from the profit max problem of the entrepreneur)
rm_c            % interst on capital patient households - consumption sector
rm_h            % interst on capital patient households - housing sector
rs              % interst on loans paid by impatient households
spread_re_rh
spread_rs_rh
ucb             % consumption bank
uce             % consumption entrepreneur 
uch             % consumption patient household
ucs             % consumption impatient household
unh_c 
unh_h 
uns_c 
uns_h 
wh_c            % wage rate patient household - consumption sector
wh_h            % wage rate patient household - housing sector
ws_c            % wage rate impatient household - consumption sector
ws_h            % wage rate impatient household - housing sector
y               % output connsumption
Z               % rental services 
zke             % utilisation rate capital entrepreneur
zkh_c           % utilisation rate capital household - consumption sector
zkh_h           % utilisation rate capital household - housing sector   
inflation
X
div      
GDP
;




varexo eps_be eps_bh eps_j eps_k eps_me eps_mh eps_p eps_zc eps_zh eps_r eps_s eps_pi eps_ME_nh eps_ME_nc;

parameters ALPHA BETAB BETAE BETAH CHIH CHIS BETAS DELTAKE DELTAKC DELTAKH DELTAHH DELTAHS DELTAHR ECH FIDB FIDH FIKE FIKC FIKH FILOEB FILOEE FILOSB FILOSS GAMMAE GAMMAS IOATA JEI KAPPAS KAPPAHN KAPPASN MIUC MIUH MIUB MIUL MK MN MS OMEGAR PSI_R PSI_PI PSI_Y RHOD RHOE RHOS SIG_BE SIG_BH SIG_J SIG_K SIG_ME SIG_MH SIG_P SIG_ZC SIG_ZH SIG_R SIG_S SIG_PI SIG_ME_NC SIG_ME_NH SIGMA SIGMAB SIGMAE SIGMAH TAUH TAUS THETAS THETA_PI ZETAE ZETAH ZRHO_ABE ZRHO_ABH ZRHO_AJ ZRHO_AK ZRHO_AME ZRHO_AMH ZRHO_AP ZRHO_AZC ZRHO_AZH ZRHO_AS X_SS ;


CHIH = 1.0732 ;
CHIS = 0.8854 ;
KAPPAHN = 1.9609 ;
KAPPASN = 1.3156 ; 

IOATA = 0.2715; 
THETA_PI = 0.3498;
PSI_R = 0.3581 ;
PSI_PI = 1.5524 ;
PSI_Y = 0.1474 ;



ALPHA = 0.35; 
BETAB = 0.945; 
BETAE = 0.94; 
BETAH =  0.9925;     
BETAS = 0.94;       
DELTAKC = 0.025; 
DELTAKH = 0.030;
DELTAKE = 0.025;
DELTAHH = 0.008 ; 
DELTAHS = 0.008 ; 
DELTAHR = 0.016 ; 
GAMMAE = 0.9; 
GAMMAS = 0.9;       
JEI = 0.075;        
MK = 0.9; 
MN = 1; 
MS = 0.9; 
SIGMAB = 1; 
SIGMAE = 1; 
SIGMAH = 1; 
TAUH = 2; 
TAUS = 2; 

KAPPAS = 2.9203; %3.6031 ;             % Rubio paper = 2
OMEGAR = 0.4475 ; %0.3119 ;        % Rubio paper = 1    
THETAS = 0.6994;% 0.6341 ;             % Rubio paper = 0.5 

X_SS = 1.15 ;   
    

SIG_BE = 9.4873e-04; 
SIG_BH = 0.0011;  
SIG_J = 0.0106; 
SIG_K = 0.0133;
SIG_ME = 0.0272; 
SIG_MH = 0.0613;  
SIG_P = 0.0163;  
SIG_ZC = 0.0090;
SIG_ZH = 0.0211;
SIG_R = 0.0220;
SIG_S = 0.0030;
SIG_PI = 0.0142 ;
SIG_ME_NC = 0.0143;
SIG_ME_NH = 0.0928;

 
ECH = 0.2190; 
FIDB = 0.2113 ; %0.137646346329159; 
FIDH = 0.2425 ; %0.0994830705225513; 
FIKE = 0.2827 ; %0.477524996640234; 
FIKC = 0.2243 ; %1.55649679224095; 
FIKH = 0.2958 ; %1.55649679224095; 
FILOEB = 0.1261 ; %0.0699784020696283;   
FILOEE = 0.3852 ; %0.0584911612503868;  
FILOSB = 0.3409 ; %0.466665017329181;  
FILOSS = 0.6904 ; %0.368243502056968;  
MIUC = 0.1639;  
MIUH = 0.10 ;
MIUB = 0.10 ;
MIUL = 0.10 ;
RHOD = 0.1906;   
RHOE = 0.1108;  
RHOS = 0.9149;           
SIGMA = 0.1678; 
ZETAE = 0.2431; %0.417264168830014; 
ZETAH = 0.0308; %0.376780917346019; 
ZRHO_ABE = 0.9077; 
ZRHO_ABH = 0.8154;  
ZRHO_AJ = 0.8621;  
ZRHO_AK = 0.9781; 
ZRHO_AME = 0.9372; 
ZRHO_AMH = 0.9480;  
ZRHO_AP = 0.8941;
ZRHO_AZC = 0.9600;  
ZRHO_AZH = 0.9012; 
ZRHO_AS = 0.95  ;


model;

#   zzrh = (1/BETAH) ; 
#   zzrm_c = zzrh - (1-DELTAKC) ; 
#   zzrm_h = zzrh - (1-DELTAKH) ;
#   zzlambdab = (1-BETAB*zzrh)/(1-BETAB*RHOD) ; 
#   zzre = (1/BETAB)*(1-((1-BETAB)*RHOD+(1-RHOD)*GAMMAE)*zzlambdab)  ;
#   zzrs = (1/BETAB)*(1-((1-BETAB)*RHOD+(1-RHOD)*GAMMAS)*zzlambdab)  ; 
#   zzlambdae = (1-BETAE*zzre)/(1-BETAE*RHOE) ; 
#   zzlambdas = (1-BETAS*zzrs)/(1-BETAS*RHOS) ;
#   zzrk = (1/BETAE)*(1-zzlambdae*(1-RHOE)*MK) - (1-DELTAKE) ; 
#   oo1 = (ALPHA*(1-MIUC))/(zzrm_c*X_SS)  ;
#   oo2 = MIUH/zzrm_h ;
#   oo3 = JEI/(1-(1-DELTAHH)*BETAH) ;
#   CAPITALGAMMASTAR = (((1-(1-DELTAHR)*BETAH)/OMEGAR)^(KAPPAS))*(OMEGAR*THETAS/(1-THETAS))*((1-(1-DELTAHS)*BETAS-zzlambdas*(1-DELTAHS)*(1-RHOS)*MS/zzrs)^(-KAPPAS)) ;
#   oo4 = (1/(1-(1-DELTAHS)*BETAS-zzlambdas*(1-DELTAHS)*(1-RHOS)*MS/zzrs))*(JEI/( 1 + ( ((1-THETAS)/THETAS)^(1/KAPPAS) )*((OMEGAR/CAPITALGAMMASTAR)^((KAPPAS-1)/KAPPAS))))  ;
#   oo5 = (oo4/CAPITALGAMMASTAR) ;
#   oo6 = (1-(1-DELTAHR)*BETAH)/OMEGAR  ;
#   oo7 = (ALPHA*MIUC)/(zzrk*X_SS)    ;
#   oo8 = X_SS*(1+zzlambdae*(1-RHOE)*MN)   ;
#   oo9 = (1+zzlambdae*(1-RHOE)*MN)   ;
#   T1 = 1 + DELTAHH*oo3 - DELTAHH*oo3*( (1-MIUH-MIUB-MIUL)*(1-SIGMA)/oo9 + (zzrm_h - DELTAKH)*oo2 + (1-zzrh)*GAMMAE*MN*(1-MIUH-MIUB-MIUL)/oo9   )  ;
#   T2 = (1-zzrh)*GAMMAS*MS*(1-DELTAHS)*oo4/zzrs + DELTAHR*oo5 - oo5*oo6*OMEGAR - (DELTAHS*oo4 + DELTAHR*oo5)*( (1-MIUH-MIUB-MIUL)*(1-SIGMA)/oo9 + (zzrm_h - DELTAKH)*oo2 + (1-zzrh)*GAMMAE*MN*(1-MIUH-MIUB-MIUL)/oo9  ) ;
#   T3 = (zzrm_c - DELTAKC)*oo1 + (1-ALPHA)*(1-SIGMA)/oo8 - (1-zzrh)*GAMMAE*( MK*oo7 - MN*(1-ALPHA)/oo8 ) + (X_SS-1)/X_SS  ;
#   T4 = 1 + oo5*oo6*OMEGAR + DELTAHS*oo4 - (1-zzrs)*MS*(1-DELTAHS)*oo4/zzrs - (DELTAHS*oo4 + DELTAHR*oo5)*(1-MIUH-MIUB-MIUL)*SIGMA/oo9 ;
#   T5 = (1-ALPHA)*SIGMA/oo8 ;
#   T6 = DELTAHH*oo3*(1-MIUH-MIUB-MIUL)*SIGMA/oo9  ;
#   T7 = DELTAKE*oo7 + (zzre-1)*( MK*oo7 - MN*(1-ALPHA)/oo8 ) + (1-ALPHA)/oo8 + zzrm_c*oo1 - 1/X_SS  ;
#   T8 = DELTAHH*oo3*( 1 - zzrm_h*oo2 - (1-MIUH-MIUB-MIUL)/oo9 - MIUB + MN*(zzre-1)*(1-MIUH-MIUB-MIUL)/oo9 );
#   T9 = (DELTAHS*oo4 + DELTAHR*oo5)*( 1 - zzrm_h*oo2 - (1-MIUH-MIUB-MIUL)/oo9 - MIUB + MN*(zzre-1)*(1-MIUH-MIUB-MIUL)/oo9 );
#   zzcstoy = ( T6*T3 + T1*T5 )/( T1*T4 + T6*T2 ) ;
#   zzchtoy = zzcstoy*T4/T6 - T5/T6 ;
#   zzcetoy = zzchtoy*T8 + zzcstoy*T9 - T7 ;
#   zzqIHtoy = DELTAHH*oo3*zzchtoy + zzcstoy*(DELTAHS*oo4 + DELTAHR*oo5) ; 
#   zznh_htonh_c = ( zzqIHtoy*(X_SS*(1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^(1/(1+KAPPAHN)) ;    
#   zzns_htons_c = ( zzqIHtoy*(X_SS*(1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^(1/(1+KAPPASN))  ;   
#   zznh_c = ( ((1/(zzchtoy))*(1-ALPHA)*(1-SIGMA)/(oo8))/(TAUH*( 1 + zzqIHtoy*X_SS*((1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)) ) )^(1/(1+CHIH)) ;
#   zzns_c = ( ((1/(zzcstoy))*(1-ALPHA)*(SIGMA)/(oo8))/(TAUS*( 1 + zzqIHtoy*X_SS*((1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^((CHIS-KAPPASN)/(1+KAPPASN)) ) )^(1/(1+CHIS)) ;
#   zznh_h = (zznh_c * zznh_htonh_c) ;
#   zzns_h = (zzns_c * zzns_htons_c)  ;
#   zzy = ( ((oo1)^(ALPHA*(1-MIUC)))*((oo7)^(ALPHA*MIUC))*((zznh_c)^((1-ALPHA)*(1-SIGMA)))*((zzns_c)^((1-ALPHA)*SIGMA)) )^(1/(1-ALPHA)) ;
#   zzkh_c = oo1*zzy  ;
#   zzqIH = zzy*zzqIHtoy ;
#   zzkh_h = oo2*zzqIH ;
#   zzkb = MIUB*zzqIH ;
#   zzke = zzy*oo7 ; 
#   zzch = zzy*zzchtoy ; 
#   zzcs = zzy*zzcstoy ; 
#   zzce = zzy*zzcetoy ;
#   zzIH = ((zzkh_h)^(MIUH))*((zznh_h)^((1-MIUH-MIUB-MIUL)*(1-SIGMA)))*((zzns_h)^((1-MIUH-MIUB-MIUL)*(SIGMA)))*((zzkb)^(MIUB)) ;
#   zzq = (zzqIH/zzIH) ;
#   zzqr = zzq*oo6 ;
#   zzhstohh = (zzcs/zzch)*(oo4/oo3) ;
#   zzhrtohh = (zzcs/zzch)*(oo5/oo3) ;
#   zzhh = (zzIH/(DELTAHH + DELTAHS*(zzhstohh) +  DELTAHR*(zzhrtohh))) ;
#   zzhs = zzhh*zzhstohh ;
#   zzhr = zzhh*zzhrtohh ;
#   zzZ = OMEGAR*zzhr ;
#   zzdiv = zzy*(X_SS-1)/X_SS ;
#   zzhstilda = ( (THETAS)^(1/KAPPAS)*(zzhs)^(1-1/KAPPAS) + (1-THETAS)^(1/KAPPAS)*(zzZ)^(1-1/KAPPAS) )^(KAPPAS/(KAPPAS-1)) ;
#   zzwh_c = (zzy/zznh_c)*(1-ALPHA)*(1-SIGMA)/(oo8)  ;
#   zzwh_h = (zzqIH/zznh_h)*(1-MIUH-MIUB-MIUL)*(1-SIGMA)/(oo9) ;
#   zzws_c = (zzy/zzns_c)*(1-ALPHA)*(SIGMA)/(oo8) ;
#   zzws_h = (zzqIH/zzns_h)*(1-MIUH-MIUB-MIUL)*(SIGMA)/(oo9) ;
#   zzlos = MS*zzq*(1-DELTAHS)*zzhs*(1/zzrs) ;
#   zzloe = MK*zzke - MN*(zzwh_c*zznh_c + zzwh_h*zznh_h + zzws_c*zzns_c + zzws_h*zzns_h )  ;
#   zzd = GAMMAE*zzloe + GAMMAS*zzlos ;
#   zzcb = (zzre-1)*zzloe + (zzrs-1)*zzlos - (zzrh-1)*zzd ;
#   zzctot = zzch + zzcs + zzce + zzcb ;
#   zzitot = DELTAKC*zzkh_c + DELTAKH*zzkh_h + DELTAKE*zzke ;
#   zzcapital_bank = zzloe + zzlos - zzd ; %capital bank 
#   zzktot = zzke + zzkh_c + zzkh_h ;
#   zzytot = zzitot + zzctot + zzkb ;
#   zzntot_c = ((zznh_c)^(1-SIGMA))*((zzns_c)^(SIGMA))  ;
#   zzntot_h = ((zznh_h)^(1-SIGMA))*((zzns_h)^(SIGMA))  ;
#   zzntot = zzntot_c + zzntot_h ;
#   zzhr_ratio = (zzhr/(zzhs + zzhh))  ;
#   zzprice_rent_ratio = zzq/zzqr ;
#   zzpl = zzq*zzIH*((BETAE*MIUL)/(1-BETAE))  ;
#   zzucb = zzcb^-SIGMAB ;
#   zzuce = zzce^-SIGMAE ;
#   zzuch = zzch^-SIGMAH ;
#   zzucs = zzcs^-SIGMAH ;
#   zzunh_c =  TAUH*(( ((zznh_c)^(1+KAPPAHN))+((zznh_h)^(1+KAPPAHN)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)))*((zznh_c)^(KAPPAHN)) ;  
#   zzunh_h =  TAUH*(( ((zznh_c)^(1+KAPPAHN))+((zznh_h)^(1+KAPPAHN)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)))*((zznh_h)^(KAPPAHN)) ;  
#   zzuns_c =  TAUS*(( ((zzns_c)^(1+KAPPASN))+((zzns_h)^(1+KAPPASN)) )^((CHIS-KAPPASN)/(1+KAPPASN)))*((zzns_c)^(KAPPASN)) ;  
#   zzuns_h =  TAUS*(( ((zzns_c)^(1+KAPPASN))+((zzns_h)^(1+KAPPASN)) )^((CHIS-KAPPASN)/(1+KAPPASN)))*((zzns_h)^(KAPPASN)) ;
#   Y_SS = (zzy) ;
#   IH_SS = zzIH ;
#   ITOT_SS = (zzitot);
#   CTOT_SS = (zzctot);
#   Q_SS = (zzq);
#   QR_SS = (zzqr) ;
#   LTOT_SS = zzloe+zzlos;
#   NTOT_C_SS = zzntot_c;
#   NTOT_H_SS = zzntot_h;
#   KE_SS = zzke;
#   KHC_SS = zzkh_c ;
#   KHH_SS = zzkh_h ;
#   RK_SS = zzrk;
#   D_SS = zzd;
#   LOE_SS = zzloe;
#   LOS_SS = zzlos;
#   HH_SS = zzhh;
#   HS_SS = zzhs;
#   HR_SS = zzhr;
#   RS_SS = zzrs;
#   HMORT_SS = zzhs  ; 
#   HHO_SS = zzhs + zzhh ;
#   HR_HTOT_SS = zzhr_ratio;
#   QQ_QR_SS = zzprice_rent_ratio ; 
#   zzloetoy=zzloe/4/zzy;
#   zzlostoy=zzlos/4/zzy;
#   zzlotoy=(zzloe+zzlos)/4/zzy;
#   zzkab=1-(zzd/(zzloe+zzlos)) ;
#   CE_SS = (zzce);
#   RE_SS = (zzre);
#   RH_SS = zzrh ;
#   LE_SS = (zzlambdae);
#   LB_SS = (zzlambdab);
#   CB_SS = (zzcb);
#   CH_SS = zzch ;
#   CS_SS = zzcs ;
#   HOWNER_SS = (zzhh + zzhs );
#   zzinflation = 1;
#   inflation_SS = zzinflation;
#	zzspread_re_rh = 4*(zzre-zzrh);
#	zzspread_rs_rh = 4*(zzrs-zzrh);
#   zzGDP = (zzctot/(zzctot+zzq*zzIH+zzitot))*zzctot + (zzq*zzIH/(zzctot+zzq*zzIH+zzitot))*zzq*zzIH + (zzitot/(zzctot+zzq*zzIH+zzitot))*zzitot ;
%#   zzGDP = zzctot + zzq*IH + zzitot ;
#   GDP_SS = zzGDP;




% Patient Household Savers  

(ch) + kh_c/exp(a_k) + kh_h + (d) + (q)*( (hh) - (1-DELTAHH)*(hh(-1)) ) + (q)*( (hr) - (1-DELTAHR)*(hr(-1)) )  - (rh(-1))*(d(-1))/inflation - (rm_c*zkh_c+(1-dkh_c)/exp(a_k))*kh_c(-1) - (rm_h*zkh_h+(1-dkh_h))*kh_h(-1) - (wh_c)*(nh_c) - (wh_h)*(nh_h) - qr*OMEGAR*hr - div = 0 ;

div = y*(X-1)/X ; 

(1+acdh)*(uch*exp(a_p)) - BETAH*(uch(+1)*exp(a_p(+1)))*(rh)/(inflation(+1)) = 0 ;

(wh_c)*uch*exp(a_p) - unh_c = 0 ;

(wh_h)*uch*exp(a_p) - unh_h = 0 ;

(1/exp(a_k)+ackh_c)*(uch*exp(a_p)) = BETAH*(uch(+1)*exp(a_p(+1)))*(rm_c(+1)*zkh_c(+1)+(1-dkh_c(+1))/exp(a_k(+1)))   ;

(1+ackh_h)*(uch*exp(a_p)) = BETAH*(uch(+1)*exp(a_p(+1)))*(rm_h(+1)*zkh_h(+1)+(1-dkh_h(+1)))   ;

(q)*uch*exp(a_p) = JEI*exp(a_j)*exp(a_p)/hh + (1-DELTAHH)*BETAH*(q(+1))*(uch(+1)*exp(a_p(+1))) ;

(1-DELTAHR)*BETAH*( uch(+1)*exp(a_p(+1))*q(+1) ) = ( uch*(exp(a_p)) )*(q-qr*OMEGAR) ;



//% Impatient Household Borrowers  


(cs) + qr*Z + (rs(-1))*(los(-1))/inflation + (q)*( (hs) - (1-DELTAHS)*(hs(-1)) ) = a_bh*(Y_SS) + (los) + (ws_c)*(ns_c) + (ws_h)*(ns_h) ;

hstilda = ( (THETAS)^(1/KAPPAS)*(hs)^(1-1/KAPPAS) + (1-THETAS)^(1/KAPPAS)*(Z)^(1-1/KAPPAS) )^(KAPPAS/(KAPPAS-1)) ;

Z = OMEGAR * hr ;
 
(los) = RHOS*(los(-1)) + (1-RHOS)*MS*exp(a_mh)*((inflation(+1))*(q(+1))*(1-DELTAHS)*(hs)/(rs(+1))) ;

(1-acloss-(lambdas))*(ucs*exp(a_p)) = BETAS*((rs/inflation(+1))-RHOS*(lambdas(+1)))*(ucs(+1)*exp(a_p(+1))) ;

(ws_c)*(ucs*exp(a_p)) - uns_c = 0 ;

(ws_h)*(ucs*exp(a_p)) - uns_h = 0 ;
 
( JEI*exp(a_j)*exp(a_p)/hstilda )*( (1-THETAS)*hstilda/Z )^(1/KAPPAS) = qr*ucs*exp(a_p) ;

q*ucs*exp(a_p) = ( JEI*exp(a_j)*exp(a_p)/hstilda )*(THETAS*hstilda/hs)^(1/KAPPAS) + (1-DELTAHS)*BETAS*q(+1)*ucs(+1)*exp(a_p) + ucs*exp(a_p)*lambdas*(1-RHOS)*MS*(1-DELTAHS)*exp(a_mh)*( inflation(+1)*q(+1)/rs(+1) ) ;



//% BANK  

(cb) + (rh(-1))*(d(-1))/inflation + (loe) + (los) - (re)*(loe(-1))/inflation - (rs(-1))*(los(-1))/inflation - (d) + (a_be+a_bh)*(Y_SS)  = 0 ; 

(d)-RHOD*( d(-1)-(loe(-1)-e_a_be(-1)*Y_SS)-(los(-1)-e_a_bh(-1)*Y_SS))-(1-(1-RHOD)*(1-GAMMAE))*(loe-e_a_be*Y_SS) -(1-(1-RHOD)*(1-GAMMAS))*(los-e_a_bh*Y_SS)  = 0;

(1-acdb-(lambdab))*ucb - BETAB*ucb(+1)*(((rh)/inflation(+1))-RHOD*lambdab(+1)) = 0 ;

(1+aclosb-(RHOD+(1-RHOD)*GAMMAS)*(lambdab))*ucb - BETAB*ucb(+1)*(((rs)/inflation(+1))-RHOD*lambdab(+1)) = 0 ;

(1+acloeb-(RHOD+(1-RHOD)*GAMMAE)*(lambdab))*ucb - BETAB*ucb(+1)*(((re(+1))/inflation(+1))-RHOD*lambdab(+1)) = 0 ;



//% Entrepreneur  

(ce) + (ke)/exp(a_k) + (re)*loe(-1)/inflation + kb + (wh_c)*(nh_c) + (wh_h)*(nh_h) + (ws_c)*(ns_c) + (ws_h)*(ns_h) + (rm_c)*zkh_c*(kh_c(-1)) + (rm_h)*zkh_h*(kh_h(-1)) = (y)/X + (q*IH) + (1-dke)*ke(-1)/exp(a_k) + (loe) + a_be*(Y_SS) ;

(y) = exp(a_zc)*((zke*(ke(-1)))^(MIUC*ALPHA))*((zkh_c*(kh_c(-1)))^((1-MIUC)*ALPHA))*((ntot_c)^(1-ALPHA))  ;

(IH) = exp(a_zh)*((zkh_h*(kh_h(-1)))^(MIUH))*((ntot_h)^(1-MIUH-MIUB-MIUL))*((kb)^(MIUB)) ;

(loe) = RHOE*(loe(-1)) + (1-RHOE)*( MK*exp(a_me)*(ke) - MN*( (wh_c)*(nh_c) + (wh_h)*(nh_h)  + (ws_c)*(ns_c) + (ws_h)*(ns_h) ) ) ;

(1-acloee-(lambdae))*uce = BETAE*((re(+1))-RHOE*lambdae(+1))*uce(+1) ;

(1/exp(a_k)+acke-(lambdae)*(1-RHOE)*MK*exp(a_me))*uce = BETAE*(rk(+1)*zke(+1)+(1-dke(+1))/exp(a_k(+1)))*uce(+1) ;

pl*(uce) = BETAE*((uce(+1))*( MIUL*(IH(+1))*(q(+1))+ (pl(+1)) ));



//% Factor demand 

ALPHA*MIUC*(y)/X = (rk)*zke*(ke(-1)) ;

ALPHA*(1-MIUC)*(y)/X = (rm_c)*zkh_c*(kh_c(-1)) ;

MIUH*q*IH = (rm_h)*zkh_h*(kh_h(-1)) ;

kb = MIUB*q*IH ; 

(1-ALPHA)*(1-SIGMA)*(y)/(X*(1+MN*exp(a_me)*(1-RHOE)*lambdae)) = (wh_c)*(nh_c) ;

(1-ALPHA)*SIGMA*(y)/(X*(1+MN*exp(a_me)*(1-RHOE)*lambdae)) = (ws_c)*(ns_c) ;

q*IH*(1-MIUH-MIUB-MIUL)*(1-SIGMA)/(1+MN*exp(a_me)*(1-RHOE)*lambdae) = (wh_h)*(nh_h) ;

q*IH*(1-MIUH-MIUB-MIUL)*SIGMA/(1+MN*exp(a_me)*(1-RHOE)*lambdae) = (ws_h)*(ns_h) ;


//% Housing supply

(hh) - (1-DELTAHH)*(hh(-1)) + (hs) - (1-DELTAHS)*(hs(-1)) + (hr) - (1-DELTAHR)*(hr(-1)) = IH ;


//% Utilization rate 

dke = DELTAKE + (RK_SS)  * ( (ZETAE/(1-ZETAE)*zke^2)/2 + (1-ZETAE/(1-ZETAE))*zke + .5*ZETAE/(1-ZETAE) - 1 ) ;

dkh_c = DELTAKC + (1/BETAH-1+DELTAKC) * ( (ZETAH/(1-ZETAH)*((zkh_c)^2))/2 + (1-ZETAH/(1-ZETAH))*zkh_c + .5*ZETAH/(1-ZETAH) - 1 ) ;

dkh_h = DELTAKH + (1/BETAH-1+DELTAKH) * ( (ZETAH/(1-ZETAH)*((zkh_h)^2))/2 + (1-ZETAH/(1-ZETAH))*zkh_h + .5*ZETAH/(1-ZETAH) - 1 ) ;

rk = (RK_SS)*( ZETAE/(1-ZETAE)*zke + 1-ZETAE/(1-ZETAE) ) ;

rm_c = (1/BETAH-1+DELTAKC)*( ZETAH/(1-ZETAH)*zkh_c + 1-ZETAH/(1-ZETAH) ) ;

rm_h = (1/BETAH-1+DELTAKH)*( ZETAH/(1-ZETAH)*zkh_h + 1-ZETAH/(1-ZETAH) ) ;


//% Price rigidites 

(inflation/((inflation(-1))^(IOATA))) = (inflation(+1)/(inflation^(IOATA)))^(BETAH) * (X/X_SS)^( -((1-THETA_PI)*(1-BETAH*THETA_PI)/THETA_PI )  ) * exp(eps_pi) ;



//% Taylor rule

rh =  ( (rh(-1))^(PSI_R) )* ( (1/BETAH)^(1-PSI_R) ) * ( (inflation)^((1-PSI_R)*PSI_PI) ) * ( (GDP/GDP(-1))^((1-PSI_R)*PSI_Y) ) * (exp(eps_r)/exp(a_s))  ;



//% Auxiliary vars 

(ktot) = (ke) + (kh_c) + (kh_h) ;

(ntot_c) = ((nh_c)^(1-SIGMA))*((ns_c)^(SIGMA))  ;

(ntot_h) = ((nh_h)^(1-SIGMA))*((ns_h)^(SIGMA))  ;

(ctot) = (ce) + (ch) + (cb) + (cs) ;

(itot) = (ke) + (kh_c) + (kh_h) - (1-dke)*(ke(-1)) - (1-dkh_c)*(kh_c(-1)) - (1-dkh_h)*(kh_h(-1)) ; 

%GDP = ctot + q*IH + itot ; 

GDP = (CTOT_SS/(CTOT_SS+Q_SS*IH_SS+ITOT_SS))*ctot + (Q_SS*IH_SS/(CTOT_SS+Q_SS*IH_SS+ITOT_SS))*q*IH + (ITOT_SS/(CTOT_SS+Q_SS*IH_SS+ITOT_SS))*itot ;

(hr_ratio) = ( hr/(hs + hh) );

(price_rent_ratio) = (q/qr) ;


//% Interest rate spreads

spread_re_rh = 4*((re)-(rh));

spread_rs_rh = 4*(rs)-4*(rh);



//% AR(1) Shock processes

a_be = ZRHO_ABE*(a_be(-1)) + eps_be ; //
a_bh = ZRHO_ABH*(a_bh(-1)) + eps_bh ; //
a_j = ZRHO_AJ*a_j(-1) + eps_j ;
a_k = ZRHO_AK*a_k(-1) + eps_k ;
a_me = ZRHO_AME*a_me(-1) + eps_me ;
a_mh = ZRHO_AMH*a_mh(-1) + eps_mh ;
a_p = ZRHO_AP*a_p(-1) + eps_p ;
a_zc = ZRHO_AZC*a_zc(-1) + eps_zc ;
a_zh = ZRHO_AZH*a_zh(-1) + eps_zh ; 
a_s = ZRHO_AS*a_s(-1) + eps_s ;

e_a_be = a_be(+1);
e_a_bh = a_bh(+1);


//% Adjustment costs

acdb  = FIDB*((d)-(d(-1)))/D_SS ;
acdh  = FIDH*((d)-(d(-1)))/D_SS ;
acke  = FIKE*((ke)-(ke(-1)))/KE_SS ;
ackh_c  = FIKC*((kh_c)-(kh_c(-1)))/KHC_SS ;
ackh_h  = FIKH*((kh_h)-(kh_h(-1)))/KHH_SS ;
acloeb = FILOEB*((loe)-(loe(-1)))/LOE_SS ;
aclosb = FILOSB*((los)-(los(-1)))/LOS_SS ;
acloee = FILOEE*((loe)-(loe(-1)))/LOE_SS ;
acloss = FILOSS*((los)-(los(-1)))/LOS_SS ;


data_TFP = a_zc ;
data_YY = (ctot + itot + kb)/Y_SS-1;   %total output
data_CC = (ctot/CTOT_SS-1)  ;    %total consumption  
data_CH = (ch/CH_SS-1) ;
data_CS = (cs/CS_SS-1) ;
data_II = (itot/ITOT_SS-1)  ;        %total investment
data_LO = ((loe+los)/LTOT_SS-1)  ;  %total loans
data_LOE = ((loe)/LOE_SS-1) ; 
data_LOH = ((los)/LOS_SS-1)  ;
data_QQ = (q/Q_SS-1) ;
data_LLE = a_be ;
data_LLH = a_bh ;
data_NN_C = ntot_c/NTOT_C_SS-1 + eps_ME_nc;
data_NN_H = ntot_h/NTOT_H_SS-1 + eps_ME_nh;
data_HH = ((hh)/HH_SS-1) ;
data_HS = ((hs)/HS_SS-1) ;
data_HR = (hr_ratio/HR_HTOT_SS-1) ;                             
data_HR_stock = ((hr)/HR_SS-1) ;
data_QR = (qr/QR_SS-1) ;
data_HMORT = (hs/HMORT_SS-1) ;
data_HHO = ((hh+hs)/HHO_SS-1) ; 
data_QQ_QR = (price_rent_ratio)/QQ_QR_SS-1;     %price-rent ratio
data_HOWNER = (((hh+hs))/HOWNER_SS)-1 ;
data_IH = (IH/IH_SS) - 1 ;
data_infl = (inflation/inflation_SS) - 1 ;
data_RH = (rh/RH_SS) - 1 ;



//% HABITS

ucb = (1-ECH)*( cb - ECH*cb(-1))^(-SIGMAB) ;
uce = (1-ECH)*( ce - ECH*ce(-1))^(-SIGMAE) ;
uch = (1-ECH)*( ch - ECH*ch(-1))^(-SIGMAH) ;
ucs = (1-ECH)*( cs - ECH*cs(-1))^(-SIGMAH) ;

unh_c =  TAUH*(( ((nh_c)^(1+KAPPAHN))+((nh_h)^(1+KAPPAHN)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)))*((nh_c)^(KAPPAHN))   ;
unh_h =  TAUH*(( ((nh_c)^(1+KAPPAHN))+((nh_h)^(1+KAPPAHN)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)))*((nh_h)^(KAPPAHN))   ;
uns_c =  TAUS*(( ((ns_c)^(1+KAPPASN))+((ns_h)^(1+KAPPASN)) )^((CHIS-KAPPASN)/(1+KAPPASN)))*((ns_c)^(KAPPASN))   ;
uns_h =  TAUS*(( ((ns_c)^(1+KAPPASN))+((ns_h)^(1+KAPPASN)) )^((CHIS-KAPPASN)/(1+KAPPASN)))*((ns_h)^(KAPPASN))   ;


end;

shocks;
var eps_be; stderr 100*SIG_BE ;
var eps_bh; stderr 100*SIG_BH ;
var eps_j; stderr 100*SIG_J ;
var eps_k; stderr 100*SIG_K ;
var eps_me; stderr 100*SIG_ME ;
var eps_mh; stderr 100*SIG_MH ;
var eps_p; stderr 100*SIG_P ;
var eps_zc; stderr 100*SIG_ZC ;
var eps_zh; stderr 100*SIG_ZH ;
var eps_r; stderr 100*SIG_R ;
var eps_s; stderr 100*SIG_S ;
var eps_pi; stderr 100*SIG_PI ;
var eps_ME_nc; stderr 100*SIG_ME_NC ;
var eps_ME_nh; stderr 100*SIG_ME_NH ;

end;

steady;

resid;

check;

model_diagnostics;

                                                                                                                                                              

stoch_simul(order=1, irf = 95, nograph, nomoments, nocorr, nofunctions) ;



%%%%% Load Data and smoothed shocks

innovations = load('innovations_smoothed');
emp_data = load('data_chapter2_demeaned'); 
variables_smoothed = load('initial_values') ;

%%%%% Empirical Data

emp_consumption = emp_data.data_CC;    
emp_housing_ratio = emp_data.data_HR;
emp_loanlosses_entr = emp_data.data_LLE;
emp_loanlosses_hh = emp_data.data_LLH;
emp_loans_entr = emp_data.data_LOE;
emp_loans_hh = emp_data.data_LOH;
emp_house_prices = emp_data.data_QQ;
emp_rental_prices = emp_data.data_QR;
emp_TFP = emp_data.data_TFP;
emp_investment = emp_data.data_II;
emp_hours_consum = emp_data.data_NN_C;
emp_hours_housing = emp_data.data_NN_H;
emp_interes_rates = emp_data.data_RH;
emp_infl = emp_data.data_infl;
emp_resid_invest = emp_data.data_IH;

n_points = length(emp_consumption);   

timeline = 1985.25:0.25:2008.75;


%%%%% initialize IRF generation

initial_values_smoothed_var = variables_smoothed.initial_values_smoothed;

initial_condition_states = repmat(initial_values_smoothed_var,1,M_.maximum_lag);

shock_matrix = zeros(n_points,M_.exo_nbr);  


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% set shocks for 'All Shocks' %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

shock_matrix(:,strmatch('eps_be',M_.exo_names,'exact')) = innovations.innovations_estimation(:,1)';
shock_matrix(:,strmatch('eps_bh',M_.exo_names,'exact')) = innovations.innovations_estimation(:,2)';
shock_matrix(:,strmatch('eps_me',M_.exo_names,'exact')) = innovations.innovations_estimation(:,5)';
shock_matrix(:,strmatch('eps_mh',M_.exo_names,'exact')) = innovations.innovations_estimation(:,6)';
shock_matrix(:,strmatch('eps_j',M_.exo_names,'exact')) = innovations.innovations_estimation(:,3)';
shock_matrix(:,strmatch('eps_k',M_.exo_names,'exact')) = innovations.innovations_estimation(:,4)';
shock_matrix(:,strmatch('eps_p',M_.exo_names,'exact')) = innovations.innovations_estimation(:,7)';
shock_matrix(:,strmatch('eps_zc',M_.exo_names,'exact')) = innovations.innovations_estimation(:,8)';
shock_matrix(:,strmatch('eps_zh',M_.exo_names,'exact')) = innovations.innovations_estimation(:,9)';
shock_matrix(:,strmatch('eps_r',M_.exo_names,'exact')) = innovations.innovations_estimation(:,10)';
shock_matrix(:,strmatch('eps_s',M_.exo_names,'exact')) = innovations.innovations_estimation(:,11)';
shock_matrix(:,strmatch('eps_pi',M_.exo_names,'exact')) = innovations.innovations_estimation(:,12)';


y2 = simult_(initial_condition_states,oo_.dr,shock_matrix,1);

y_IRF_all_shocks = y2(:,M_.maximum_lag+1:end)-repmat(oo_.dr.ys,1,n_points); %substract steady state



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% Create Figure All Shocks - Initial Values = Smoothed Variables  %%%%%%%%%%%%%%%%%%%%%%


ff=figure('Name','Response to All Shocks - Initial Values = Smoothed Variables');

h1=subtightplot(2,2,1,[0.1,0.04]);
hh1=plot(timeline, 100*y_IRF_all_shocks(strmatch('data_QQ',M_.endo_names,'exact'),:),'b-.','LineWidth',1.5);
hold on
hh2=plot(timeline,100*(emp_house_prices),'g','LineWidth',1.5);
hold off
ll=legend([hh1 hh2],'Model','Data');
set(ll,'Location','NorthWest','fontsize',16);  
axis tight;    
grid on; 
title('House Prices', 'fontsize',20);
xticks([1985.25 1990.25 1995.25 2000.25 2005.25 2010.25 ]);
xticklabels({'1985','1990','1995','2000','2005','2010'});


h2=subtightplot(2,2,2,[0.1,0.04]);
hh1=plot(timeline, 100*y_IRF_all_shocks(strmatch('data_QR',M_.endo_names,'exact'),:),'b-.','LineWidth',1.5);
hold on
hh2=plot(timeline, 100*(emp_rental_prices),'g','LineWidth',1.5);
hold off
axis tight;   
grid on;  
title('Rental Prices', 'fontsize',20);
xticks([1985.25 1990.25 1995.25 2000.25 2005.25 2010.25 ]);
xticklabels({'1985','1990','1995','2000','2005','2010'});


h3=subtightplot(2,2,3,[0.1,0.04]);
hh1=plot(timeline,100*y_IRF_all_shocks(strmatch('data_HR',M_.endo_names,'exact'),:),'b-.','LineWidth',1.5);   
hold on
hh2=plot(timeline,100*(emp_housing_ratio),'g','LineWidth',1.5);
hold off
axis tight;
grid on; 
title('Rental/Homeowner Ratio', 'fontsize',20);
set([h1,h2,h3],'fontsize',20);
xticks([1985.25 1990.25 1995.25 2000.25 2005.25 2010.25 ]);
xticklabels({'1985','1990','1995','2000','2005','2010'});






