function [ys,check]=rob30_steadystate(ys,junk)

global M_ 

% read out parameters to access them with their name
NumberOfParameters = M_.param_nbr;
for ii = 1:NumberOfParameters
  paramname = deblank(M_.param_names(ii,:)); %deblank gets rid of white spaces e.g. 'DELTA     ' becomes 'DELTA'
  eval([ paramname ' = M_.params(' int2str(ii) ');']);
end
% initialize indicator
check = 0;


%Interest Rates and Multipliers 

rh = (1/BETAH); 

rm_c = rh - (1-DELTAKC) ; 

rm_h = rh - (1-DELTAKH) ; 

lambdab = (1-BETAB*rh)/(1-BETAB*RHOD) ;  

re = (1/BETAB)*(1-((1-BETAB)*RHOD+(1-RHOD)*GAMMAE)*lambdab)  ; 

rs = (1/BETAB)*(1-((1-BETAB)*RHOD+(1-RHOD)*GAMMAS)*lambdab)  ; 

lambdae = (1-BETAE*re)/(1-BETAE*RHOE) ; 

lambdas = (1-BETAS*rs)/(1-BETAS*RHOS) ; 

rk = (1/BETAE)*(1-lambdae*(1-RHOE)*MK) - (1-DELTAKE) ; 

%Constants

oo1 = (ALPHA*(1-MIUC))/(rm_c*X_SS)  ;

oo2 = MIUH/rm_h ;

oo3 = JEI/(1-(1-DELTAHH)*BETAH) ;

CAPITALGAMMASTAR = (((1-(1-DELTAHR)*BETAH)/OMEGAR)^(KAPPAS))*(OMEGAR*THETAS/(1-THETAS))*((1-(1-DELTAHS)*BETAS-lambdas*(1-DELTAHS)*(1-RHOS)*MS/rs)^(-KAPPAS)) ;

oo4 = (1/(1-(1-DELTAHS)*BETAS-lambdas*(1-DELTAHS)*(1-RHOS)*MS/rs))*(JEI/( 1 + ( ((1-THETAS)/THETAS)^(1/KAPPAS) )*((OMEGAR/CAPITALGAMMASTAR)^((KAPPAS-1)/KAPPAS)))) ;

oo5 = (oo4/CAPITALGAMMASTAR) ;

oo6 = (1-(1-DELTAHR)*BETAH)/OMEGAR  ;

oo7 = (ALPHA*MIUC)/(rk*X_SS)    ;

oo8 = X_SS*(1+lambdae*(1-RHOE)*MN)   ;

oo9 = (1+lambdae*(1-RHOE)*MN)   ;

T1 = 1 + DELTAHH*oo3 - DELTAHH*oo3*( (1-MIUH-MIUB-MIUL)*(1-SIGMA)/oo9 + (rm_h - DELTAKH)*oo2 + (1-rh)*GAMMAE*MN*(1-MIUH-MIUB-MIUL)/oo9   ) ;

T2 = (1-rh)*GAMMAS*MS*(1-DELTAHS)*oo4/rs + DELTAHR*oo5 - oo5*oo6*OMEGAR - (DELTAHS*oo4 + DELTAHR*oo5)*( (1-MIUH-MIUB-MIUL)*(1-SIGMA)/oo9 + (rm_h - DELTAKH)*oo2 + (1-rh)*GAMMAE*MN*(1-MIUH-MIUB-MIUL)/oo9  ) ;

T3 = (rm_c - DELTAKC)*oo1 + (1-ALPHA)*(1-SIGMA)/oo8 - (1-rh)*GAMMAE*( MK*oo7 - MN*(1-ALPHA)/oo8 ) + (X_SS-1)/X_SS ;

T4 = 1 + oo5*oo6*OMEGAR + DELTAHS*oo4 - (1-rs)*MS*(1-DELTAHS)*oo4/rs - (DELTAHS*oo4 + DELTAHR*oo5)*(1-MIUH-MIUB-MIUL)*SIGMA/oo9 ;

T5 = (1-ALPHA)*SIGMA/oo8 ;

T6 = DELTAHH*oo3*(1-MIUH-MIUB-MIUL)*SIGMA/oo9  ;

T7 = DELTAKE*oo7 + (re-1)*( MK*oo7 - MN*(1-ALPHA)/oo8 ) + (1-ALPHA)/oo8 + rm_c*oo1 - 1/X_SS ;

T8 = DELTAHH*oo3*( 1 - rm_h*oo2 - (1-MIUH-MIUB-MIUL)/oo9 - MIUB + MN*(re-1)*(1-MIUH-MIUB-MIUL)/oo9 );

T9 = (DELTAHS*oo4 + DELTAHR*oo5)*( 1 - rm_h*oo2 - (1-MIUH-MIUB-MIUL)/oo9 - MIUB + MN*(re-1)*(1-MIUH-MIUB-MIUL)/oo9 );

% Ratios

cstoy = ( T6*T3 + T1*T5 )/( T1*T4 + T6*T2 ) ;

chtoy = cstoy*T4/T6 - T5/T6 ;

cetoy = chtoy*T8 + cstoy*T9 - T7 ;

qIHtoy = DELTAHH*oo3*chtoy + cstoy*(DELTAHS*oo4 + DELTAHR*oo5) ; 

% Levels

nh_htonh_c = ( qIHtoy*(X_SS*(1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^(1/(1+KAPPAHN)) ;    %nh_h divided by nh_c

ns_htons_c = ( qIHtoy*(X_SS*(1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^(1/(1+KAPPASN))  ;   %ns_h divided by ns_c

nh_c = ( ((1/(chtoy))*(1-ALPHA)*(1-SIGMA)/(oo8))/(TAUH*( 1+qIHtoy*X_SS*((1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)) ) )^(1/(1+CHIH)) ;

ns_c = ( ((1/(cstoy))*(1-ALPHA)*(SIGMA)/(oo8))/(TAUS*( 1+qIHtoy*X_SS*((1-MIUH-MIUB-MIUL)/(1-ALPHA)) )^((CHIS-KAPPASN)/(1+KAPPASN)) ) )^(1/(1+CHIS)) ;

nh_h = (nh_c * nh_htonh_c) ;

ns_h = (ns_c * ns_htons_c)  ;

y = ( ((oo1)^(ALPHA*(1-MIUC)))*((oo7)^(ALPHA*MIUC))*((nh_c)^((1-ALPHA)*(1-SIGMA)))*((ns_c)^((1-ALPHA)*SIGMA)) )^(1/(1-ALPHA)) ;

kh_c = oo1*y  ;

qIH = y*qIHtoy ;

kh_h = oo2*qIH ;

kb = MIUB*qIH ;

ke = y*oo7 ; 

ch = y*chtoy ; 

cs = y*cstoy ; 

ce = y*cetoy ;

IH = ((kh_h)^(MIUH))*((nh_h)^((1-MIUH-MIUB-MIUL)*(1-SIGMA)))*((ns_h)^((1-MIUH-MIUB-MIUL)*(SIGMA)))*((kb)^(MIUB)) ;

q = (qIH/IH) ;

qr = q*oo6 ;

hstohh = (cs/ch)*(oo4/oo3) ;

hrtohh = (cs/ch)*(oo5/oo3) ;

hh = (IH/(DELTAHH + DELTAHS*(hstohh) +  DELTAHR*(hrtohh))) ;

hs = hh*hstohh ;

hr = hh*hrtohh ;

Z = OMEGAR*hr ;

div = y*(X_SS-1)/X_SS ;

hstilda = ( (THETAS)^(1/KAPPAS)*(hs)^(1-1/KAPPAS) + (1-THETAS)^(1/KAPPAS)*(Z)^(1-1/KAPPAS) )^(KAPPAS/(KAPPAS-1)) ;

wh_c = (y/nh_c)*(1-ALPHA)*(1-SIGMA)/(oo8)  ;

wh_h = (qIH/nh_h)*(1-MIUH-MIUB-MIUL)*(1-SIGMA)/(oo9) ;

ws_c = (y/ns_c)*(1-ALPHA)*(SIGMA)/(oo8) ;

ws_h = (qIH/ns_h)*(1-MIUH-MIUB-MIUL)*(SIGMA)/(oo9) ;

los = MS*q*(1-DELTAHS)*hs*(1/rs) ;

loe = MK*ke - MN*(wh_c*nh_c + wh_h*nh_h + ws_c*ns_c + ws_h*ns_h )  ;

d = GAMMAE*loe + GAMMAS*los ;

cb = (re-1)*loe + (rs-1)*los - (rh-1)*d ;

ctot = ch + cs + ce + cb ;

itot = DELTAKC*kh_c + DELTAKH*kh_h + DELTAKE*ke ;

capital_bank = loe + los - d ; %capital bank 

ktot = ke + kh_c + kh_h ;

ytot = itot + ctot + kb ;

ntot_c = ((nh_c)^(1-SIGMA))*((ns_c)^(SIGMA))  ;

ntot_h = ((nh_h)^(1-SIGMA))*((ns_h)^(SIGMA))  ;

ntot = ntot_c + ntot_h ;

hr_ratio = (hr/(hs + hh))  ;

price_rent_ratio = q/qr ;

pl = q*IH*((BETAE*MIUL)/(1-BETAE))  ;

spread_re_rh = 4*(re-rh);

spread_rs_rh = 4*(rs-rh);

ucb = cb^-SIGMAB ;

uce = ce^-SIGMAE ;

uch = ch^-SIGMAH ;

ucs = cs^-SIGMAH ;

unh_c =  TAUH*(( ((nh_c)^(1+KAPPAHN))+((nh_h)^(1+KAPPAHN)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)))*((nh_c)^(KAPPAHN)) ;  

unh_h =  TAUH*(( ((nh_c)^(1+KAPPAHN))+((nh_h)^(1+KAPPAHN)) )^((CHIH-KAPPAHN)/(1+KAPPAHN)))*((nh_h)^(KAPPAHN)) ;  

uns_c =  TAUS*(( ((ns_c)^(1+KAPPASN))+((ns_h)^(1+KAPPASN)) )^((CHIS-KAPPASN)/(1+KAPPASN)))*((ns_c)^(KAPPASN)) ;  

uns_h =  TAUS*(( ((ns_c)^(1+KAPPASN))+((ns_h)^(1+KAPPASN)) )^((CHIS-KAPPASN)/(1+KAPPASN)))*((ns_h)^(KAPPASN)) ;


acdb=0;
acdh=0;
ache=0;
achh=0;
achs=0;
acke=0;
ackh_c=0;
ackh_h=0;
acloeb=0;
aclosb=0;
acloee=0;
acloss=0;


Y_SS = (y) ;

ITOT_SS = (itot);

CTOT_SS = (ctot);

Q_SS = (q);

QR_SS = qr ;

QQ_QR_SS = price_rent_ratio;

PL_SS = pl ;

LTOT_SS = loe+los;

NTOT_C_SS = ntot_c ;

NTOT_H_SS = ntot_h ; 

KE_SS = ke;

KHC_SS = kh_c ;

KHH_SS = kh_h ;

RK_SS = rk;

D_SS = d;

LOE_SS = loe;

LOS_SS = los;

HH_SS = hh;

HS_SS = hs ;

HR_SS = hr ;

HMORT_SS = hs  ;

HHO_SS = hh + hs ;

HR_HTOT_SS = (hr_ratio) ;

IH_SS = (IH) ;

inflation = 1;

inflation_SS = inflation; 

X = X_SS ;

GDP = (ctot/(ctot+q*IH+itot))*ctot + (q*IH/(ctot+q*IH+itot))*q*IH + (itot/(ctot+q*IH+itot))*itot ; 

intshare = 1;

loetoy=loe/4/y;
lostoy=los/4/y;
lotoy=(loe+los)/4/y;


kab=1-(d/(loe+los));

data_CC=0;
data_CH=0;
data_CS=0;
data_II=0;
data_LLE =0;
data_LLH = 0;
data_LL=0;
data_LO=0;
data_LOE=0;
data_LOH=0;
data_QQ=0;
data_YY=0;
data_YL=0;
data_TFP=0;
data_NN_C=0;
data_NN_H=0;
data_HS=0;
data_HR=0;
data_HR_stock = 0;
data_HE=0;
data_QR=0;
data_HMORT=0;
data_HHO = 0; 
data_HH =0;
data_RS =0;
data_QQ_QR = 0;
data_HOWNER = 0;
data_IH = 0;
data_infl = 0;
data_RH = 0;
data_GDP = 0;



zke = 1;
zkh_c = 1;
zkh_h = 1;
dke = DELTAKE;
dkh_c =DELTAKC;
dkh_h =DELTAKH;

CE_SS = ce;
CH_SS = ch;
RE_SS = re;
LE_SS = lambdae;
LB_SS = lambdab;
CB_SS = cb;
CS_SS = cs;


a_be=0;
a_bh=0;
a_j=0;
a_k=0;
a_me=0;
a_mh=0;
a_p=0;
a_zc=0;
a_zh=0;
a_s=0;

e_a_be=0;
e_a_bh=0;

%% end own model equations

for iter = 1:length(M_.params) %update parameters set in the file
  eval([ 'M_.params(' num2str(iter) ') = ' M_.param_names(iter,:) ';' ])
end

NumberOfEndogenousVariables = M_.orig_endo_nbr; %auxiliary variables are set automatically
for ii = 1:NumberOfEndogenousVariables
  varname = deblank(M_.endo_names(ii,:));
  eval(['ys(' int2str(ii) ') = ' varname ';']);
end